Index: ow/fit.py
===================================================================
--- ow/fit.py	(revision 119412db9c0fbd52a4c2e76feaddd0d23de5b3d2)
+++ ow/fit.py	(revision b73ae0995b336b6d319436813d7a76896bebeb66)
@@ -3,10 +3,10 @@
 import gpxpy.gpx
 
-try:
+try:  # pragma: no cover
     import lxml.etree as mod_etree  # Load LXML or fallback to cET or ET
-except:
+except ImportError:  # pragma: no cover
     try:
         import xml.etree.cElementTree as mod_etree
-    except:
+    except ImportError:
         import xml.etree.ElementTree as mod_etree
 
Index: ow/tests/models/test_workout.py
===================================================================
--- ow/tests/models/test_workout.py	(revision 119412db9c0fbd52a4c2e76feaddd0d23de5b3d2)
+++ ow/tests/models/test_workout.py	(revision b73ae0995b336b6d319436813d7a76896bebeb66)
@@ -11,4 +11,5 @@
 from ow.models.user import User
 from ow.models.root import OpenWorkouts
+from ow.utilities import create_blob
 
 
@@ -121,4 +122,11 @@
         assert workout.duration_seconds == '15'
 
+    def test__duration(self):
+        # covering the property that shows the duration of a workout properly
+        # formatted in hours:minutes:seconds
+        duration = timedelta(hours=1, minutes=30, seconds=15)
+        workout = Workout(duration=duration)
+        assert workout._duration == '01:30:15'
+
     def test_rounded_distance_no_value(self):
         workout = Workout()
@@ -209,4 +217,17 @@
         assert workout.tracking_file_path == '/var/db/blobs/blobfile'
 
+    def test_fit_file_path(self):
+        workout = Workout()
+        # no tracking file, path is None
+        assert workout.fit_file_path is None
+        # workout still not saved to the db
+        workout.fit_file = Mock()
+        workout.fit_file._p_blob_uncommitted = '/tmp/blobtempfile'
+        workout.fit_file._p_blob_committed = None
+        assert workout.fit_file_path == '/tmp/blobtempfile'
+        workout.fit_file._p_blob_uncommitted = None
+        workout.fit_file._p_blob_committed = '/var/db/blobs/blobfile'
+        assert workout.fit_file_path == '/var/db/blobs/blobfile'
+
     def test_load_from_file_invalid(self):
         workout = Workout()
@@ -222,4 +243,11 @@
             workout.load_from_file()
             assert lfg.called
+
+    def test_load_from_file_fit(self):
+        workout = Workout()
+        workout.tracking_filetype = 'fit'
+        with patch.object(workout, 'load_from_fit') as lff:
+            workout.load_from_file()
+            assert lff.called
 
     gpx_params = (
@@ -372,4 +400,115 @@
         assert res == {}
 
+    fit_params = (
+        # complete fit file from a garmin 520 device
+        ('fixtures/20181230_101115.fit', {
+            'start': datetime(2018, 12, 30, 9, 11, 15, tzinfo=timezone.utc),
+            'duration': timedelta(0, 13872, 45000),
+            'distance': Decimal('103.4981999999999970896169543'),
+            'title': 'Synapse cycling',
+            'hr': {'min': 93, 'max': 170, 'avg': 144},
+            'cad': {'min': 0, 'max': 121, 'avg': 87},
+            'atemp': {'min': -4, 'max': 15, 'avg': 2},
+            'gpx_file': 'fixtures/20181230_101115.gpx'}),
+        # fit file from a garmin 520 without heart rate or cadence data
+        ('fixtures/20181231_110728.fit', {
+            'start': datetime(2018, 12, 31, 10, 7, 28, tzinfo=timezone.utc),
+            'duration': timedelta(0, 2373, 142000),
+            'distance': Decimal('6.094909999999999854480847716'),
+            'title': 'Synapse cycling',
+            'hr': None,
+            'cad': None,
+            'atemp': {'min': -1, 'max': 11, 'avg': 1},
+            'gpx_file': 'fixtures/20181231_110728.gpx'}),
+    )
+
+    @pytest.mark.parametrize(('filename', 'expected'), fit_params)
+    def test_load_from_fit(self, filename, expected):
+        """
+        Load a fit file located in tests/fixtures using the load_from_fit()
+        method of the Workout model, then check that certain attrs on the
+        workout are updated correctly.
+
+        Ensure also that the proper gpx file is created automatically from
+        the fit file, with the proper contents (we have a matching gpx file
+        in tests/fixtures for each fit file)
+        """
+        # expected values
+        start = expected['start']
+        duration = expected['duration']
+        distance = expected['distance']
+        title = expected['title']
+        hr = expected['hr']
+        cad = expected['cad']
+        atemp = expected['atemp']
+        # gpx_file = expected['gpx_file']
+
+        workout = Workout()
+
+        # Check the values are different by default
+        assert workout.start != start
+        assert workout.duration != duration
+        assert workout.distance != distance
+
+        # by default no tracking file and no fit file are associated with this
+        # workout.
+        assert workout.tracking_file is None
+        assert workout.fit_file is None
+        assert not workout.has_tracking_file
+        assert not workout.has_gpx
+        assert not workout.has_fit
+
+        fit_file_path = os.path.join(
+            os.path.dirname(os.path.dirname(__file__)), filename)
+
+        # gpx_file_path = os.path.join(
+        #     os.path.dirname(os.path.dirname(__file__)), gpx_file)
+
+        # add the fit file as a blob to tracking_file
+        with open(fit_file_path, 'rb') as fit_file:
+            fit_blob = create_blob(fit_file.read(), file_extension='fit',
+                                   binary=True)
+        workout.tracking_file = fit_blob
+        workout.tracking_filetype = 'fit'
+
+        res = workout.load_from_fit()
+
+        assert res is True
+        assert workout.start == start
+        assert workout.duration == duration
+        assert isinstance(workout.distance, Decimal)
+        assert round(workout.distance) == round(distance)
+        # The title of the workout is taken from the gpx file
+        assert workout.title == title
+
+        if hr is not None:
+            for k in hr.keys():
+                # We use 'fail' as the fallback in the getattr call
+                # because None is one of the posible values, and we
+                # want to be sure those attrs are there
+                value = getattr(workout, 'hr_' + k, 'fail')
+                # Use round() to avoid problems when comparing long
+                # Decimal objects
+                assert round(hr[k]) == round(value)
+
+        if cad is not None:
+            for k in cad.keys():
+                value = getattr(workout, 'cad_' + k, 'fail')
+                assert round(cad[k]) == round(value)
+
+        if atemp is not None:
+            for k in atemp.keys():
+                value = getattr(workout, 'atemp_' + k, 'fail')
+                assert round(atemp[k]) == round(value)
+
+        assert workout.tracking_file is not None
+        # the tracking file type is set back to gpx, as we have
+        # automatically generated the gpx version
+        assert workout.tracking_filetype == 'gpx'
+        assert workout.fit_file is not None
+        assert workout.has_tracking_file
+        assert workout.has_gpx
+        assert workout.has_fit
+
     def test_has_tracking_file(self, root):
         workout = root['john']['1']
Index: ow/tests/test_fit.py
===================================================================
--- ow/tests/test_fit.py	(revision b73ae0995b336b6d319436813d7a76896bebeb66)
+++ ow/tests/test_fit.py	(revision b73ae0995b336b6d319436813d7a76896bebeb66)
@@ -0,0 +1,289 @@
+import os
+from datetime import datetime
+from unittest.mock import Mock
+
+import pytest
+from fitparse import FitFile
+from fitparse.utils import FitHeaderError
+
+from ow.fit import Fit
+
+
+class TestFit(object):
+
+    def get_fixture_path(self, filename):
+        here = os.path.abspath(os.path.dirname(__file__))
+        path = os.path.join(here, 'fixtures', filename)
+        return path
+
+    @pytest.fixture
+    def fit(self):
+        # fit file used in most of the tests below
+        fit_path = self.get_fixture_path('20181230_101115.fit')
+        fit = Fit(fit_path)
+        return fit
+
+    @pytest.fixture
+    def values(self):
+        return {
+            'sport': 'cycling',
+            'unknown_110': 'OpenWorkouts-testing',
+            'start_time': datetime.now(),
+            'total_timer_time': 3600,
+            'total_elapsed_time': 3700,
+            'total_distance': 60000,
+            'total_ascent': 1200,
+            'total_descent': 1100,
+            'total_calories': 2000,
+            'max_heart_rate': 180,
+            'avg_heart_rate': 137,
+            'max_cadence': 111,
+            'avg_cadence': 90,
+            'enhanced_max_speed': 16.666,
+            'max_speed': 18666,
+            'enhanced_avg_speed': 7.638,
+            'avg_speed': 7838
+        }
+
+    @pytest.fixture
+    def expected(self, values):
+        return {
+            'sport': 'cycling',
+            'profile': 'OpenWorkouts-testing',
+            'start': values['start_time'],
+            'duration': 3600,
+            'elapsed': 3700,
+            'distance': 60000,
+            'uphill': 1200,
+            'downhill': 1100,
+            'calories': 2000,
+            'hr': [],
+            'min_hr': None,
+            'max_hr': 180,
+            'avg_hr': 137,
+            'cad': [],
+            'min_cad': None,
+            'max_cad': 111,
+            'avg_cad': 90,
+            'max_speed': 16.666,
+            'avg_speed': 7.638,
+            'atemp': [],
+            'min_atemp': None,
+            'max_atemp': 0,
+            'avg_atemp': 0,
+        }
+
+    fit_files = [
+        ('non-existant.fit', FileNotFoundError),
+        ('20131013.gpx', FitHeaderError),  # GPX file
+        ('20181230_101115.fit', None),  # FIT file
+    ]
+
+    @pytest.mark.parametrize(('filename', 'expected'), fit_files)
+    def test__init__(self, filename, expected):
+        fit_path = self.get_fixture_path(filename)
+        if expected is None:
+            fit = Fit(fit_path)
+            assert isinstance(fit, Fit)
+            assert fit.path == fit_path
+            assert isinstance(fit.obj, FitFile)
+            assert fit.data == {}
+        else:
+            with pytest.raises(expected):
+                Fit(fit_path)
+
+    def test_load_real_fit_file(self, fit):
+        """
+        Test loading data from a real fit file from a Garmin device
+        """
+        assert fit.data == {}
+        fit.load()
+        assert len(fit.data.keys()) == 23
+
+    def test_load_extra_cases(self, fit, values, expected):
+        """
+        Test loading data from some mocked file, so we can be sure all the
+        loading code is executed and covered by tests
+        """
+        # first mock the FitFile object in the fit object
+        session = Mock()
+        session.get_values.return_value = values
+        fit.obj = Mock()
+        # mock get_messages, no matter what we ask for, return a single
+        # session list, which fits for the purpose of this test
+        fit.obj.get_messages.return_value = [session]
+
+        assert fit.data == {}
+
+        # first load, we have all data we are supposed to have in the fit
+        # file, so results are more or less like in the real test
+        fit.load()
+        assert len(fit.data.keys()) == 23
+        for k in expected.keys():
+            assert fit.data[k] == expected[k]
+
+        # now, remove enhanced_max_speed, so the max_speed parameter is used
+        values['enhanced_max_speed'] = None
+        fit.load()
+        assert len(fit.data.keys()) == 23
+        for k in expected.keys():
+            if k == 'max_speed':
+                assert fit.data[k] != expected[k]
+                assert fit.data[k] == 18.666
+            else:
+                assert fit.data[k] == expected[k]
+
+        # now, do the same for the avg speed
+        values['enhanced_max_speed'] = 16.666
+        values['enhanced_avg_speed'] = None
+        fit.load()
+        assert len(fit.data.keys()) == 23
+        for k in expected.keys():
+            if k == 'avg_speed':
+                assert fit.data[k] != expected[k]
+                assert fit.data[k] == 7.838
+            else:
+                assert fit.data[k] == expected[k]
+
+    def test_name(self, fit):
+        # without loading first, no data, so it blows up
+        with pytest.raises(KeyError):
+            fit.name
+        fit.load()
+        # the default fit file has both profile and sport
+        assert fit.name == 'Synapse cycling'
+        # remove profile
+        fit.data['profile'] = None
+        assert fit.name == 'cycling'
+        # change sport
+        fit.data['sport'] = 'running'
+        assert fit.name == 'running'
+
+    def test__calculate_avg_atemp(self, fit):
+        # before loading data, we don't have any info about the average temp
+        assert 'avg_atemp' not in fit.data.keys()
+        # loaded data, fit file didn't have that info pre-calculated
+        fit.load()
+        assert fit.data['avg_atemp'] == 0
+        # this loads the needed temperature data into fit.data + calls
+        # _calculate_avg_atemp
+        fit.gpx
+        # now we have the needed info
+        assert fit.data['avg_atemp'] == 2
+
+    def test_gpx_without_load(self, fit):
+        # without loading first, no data, so it blows up
+        with pytest.raises(KeyError):
+            fit.gpx
+
+    def test_gpx_real_fit_file(self, fit):
+        """
+        Test the gpx generation code with a real fit file from a garmin device
+        """
+        fit.load()
+        # open a pre-saved gpx file, the generated gpx file has to be like
+        # this one
+        gpx_path = self.get_fixture_path('20181230_101115.gpx')
+        with open(gpx_path, 'r') as gpx_file:
+            expected = gpx_file.read()
+        assert fit.gpx == expected
+
+    def test_gpx_extra_cases(self, fit, values):
+        """
+        Test the gpx generation code with some mocked data, so we can be sure
+        all the code is executed and covered by tests
+        """
+        # first mock the FitFile object in the fit object
+        session = Mock()
+        session.get_values.return_value = values
+        fit.obj = Mock()
+        # mock get_messages, no matter what we ask for, return a single
+        # session list, which fits for the purpose of this test
+        fit.obj.get_messages.return_value = [session]
+        fit.load()
+        # after loading data, mock again get_messages, this time return the
+        # list of messages we will loop over to generate the gpx object
+        first_values = {
+            'temperature': 18,
+            'heart_rate': 90,
+            'cadence': 40,
+            'position_long': -104549248,
+            'position_lat': 508158836,
+            'enhanced_altitude': 196.79999999999995,
+            'enhanced_speed': 5.432,
+            'timestamp': datetime.now()
+        }
+        first_record = Mock()
+        first_record.get_values.return_value = first_values
+        second_values = {
+            'temperature': 16,
+            'heart_rate': 110,
+            'cadence': 70,
+            'position_long': -104532648,
+            'position_lat': 508987836,
+            'enhanced_altitude': 210.79999999999995,
+            'enhanced_speed': 10.432,
+            'timestamp': datetime.now()
+        }
+        second_record = Mock()
+        second_record.get_values.return_value = second_values
+
+        third_values = {
+            'temperature': 7,
+            'heart_rate': 140,
+            'cadence': 90,
+            'position_long': -104532876,
+            'position_lat': 508987987,
+            'enhanced_altitude': 250.79999999999995,
+            'enhanced_speed': 9.432,
+            'timestamp': datetime.now()
+        }
+        third_record = Mock()
+        third_record.get_values.return_value = third_values
+
+        # set an hr value of 0, which will trigger the code that sets
+        # the minimum heart rate value from the last known value
+        fourth_values = {
+            'temperature': -2,
+            'heart_rate': 0,
+            'cadence': 0,
+            'position_long': -104532876,
+            'position_lat': 508987987,
+            'enhanced_altitude': 250.79999999999995,
+            'enhanced_speed': 9.432,
+            'timestamp': datetime.now()
+        }
+        fourth_record = Mock()
+        fourth_record.get_values.return_value = fourth_values
+
+        records = [
+            first_record,
+            second_record,
+            third_record,
+            fourth_record,
+        ]
+
+        fit.obj.get_messages.return_value = records
+        xml = fit.gpx
+
+        # now, ensure the proper data is in the xml file
+        #
+        # no 0 hr value is in there
+        assert '<gpxtpx:hr>0</gpxtpx:hr>' not in xml
+        # but the previous value is twice
+        assert xml.count('<gpxtpx:hr>140</gpxtpx:hr>') == 2
+
+        # the other values appear once
+        assert xml.count('<gpxtpx:hr>90</gpxtpx:hr>') == 1
+        assert xml.count('<gpxtpx:hr>110</gpxtpx:hr>') == 1
+        for v in [18, 16, 7, -2]:
+            assert '<gpxtpx:atemp>' + str(v) + '</gpxtpx:atemp>' in xml
+        for v in [40, 70, 90, 0]:
+            assert '<gpxtpx:cad>' + str(v) + '</gpxtpx:cad>' in xml
+
+        # the name provided by the fit object is there
+        assert '<name>' + fit.name + '</name>' in xml
+        # and we have 4 track points, no need to check the latitude/longitude
+        # conversion, as that is covered in the previous test with a real fit
+        # and gpx files test
+        assert xml.count('<trkpt lat') == 4
Index: ow/tests/test_utilities.py
===================================================================
--- ow/tests/test_utilities.py	(revision 119412db9c0fbd52a4c2e76feaddd0d23de5b3d2)
+++ ow/tests/test_utilities.py	(revision b73ae0995b336b6d319436813d7a76896bebeb66)
@@ -5,5 +5,16 @@
 import pytest
 
-from ow.utilities import slugify, GPXMinidomParser
+from ow.utilities import (
+    slugify,
+    GPXMinidomParser,
+    semicircles_to_degrees,
+    degrees_to_semicircles,
+    miles_to_kms,
+    kms_to_miles,
+    meters_to_kms,
+    kms_to_meters,
+    mps_to_kmph,
+    kmph_to_mps,
+)
 
 
@@ -19,4 +30,28 @@
         res = slugify(u'(r)-[i]\u00AE')
         assert res == u'r-i-r'
+
+    def test_semicircles_to_degrees(self):
+        assert semicircles_to_degrees(10) == 10 * (180 / pow(2, 31))
+
+    def test_degrees_to_semicircles(self):
+        assert degrees_to_semicircles(10) == 10 * (pow(2, 31) / 180)
+
+    def test_miles_to_kms(self):
+        assert miles_to_kms(100) == 100 / 0.62137119
+
+    def test_kms_to_miles(self):
+        assert kms_to_miles(100) == 100 * 0.62137119
+
+    def test_meters_to_kms(self):
+        assert meters_to_kms(1000) == 1
+
+    def test_kms_to_meters(self):
+        assert kms_to_meters(1) == 1000
+
+    def test_mps_to_kmph(self):
+        assert mps_to_kmph(5) == 5 * 3.6
+
+    def test_kmph_to_mps(self):
+        assert kmph_to_mps(30) == 30 * 0.277778
 
 
